{$R+}
Program spectr3; uses dos;
{est` matritsy H, S, X1..X3 (3-mer. sluchaj), poschitann. v predyd. prog-me
  iz kompleksa prog-m dlq nakhozhd. koleb. sp-ra v proizv. potentsiale;
  dann. prog. chitaet eti matr., diagonaliz. i vyv. spektry.
  Vyv. tzh. SZ i SV; SV mozhno vposl. ispol`z. dlq vizualiz. VF posle
  diag-cii.
}
{vse energii - v sm-1}

 {$i diaggrib.pas}
 {$i constant.pas}
 {$i uses_gra.pas}

 var S,H:ma; SV,X1,X2,X3:^matr; SZ:vect;
 var b,bb:text; n,i,j,m,p,q:integer;
 var kT,ny,intens_,exp_E_kT,intens1,intens2,intens3:real;
 var x0_,x1_,x:real;
 var x0_e,x1_e,y0_e,y1_e:real; nx,ny_:integer;
 var Emax,arg:real; n_Emax:integer;
 var et,e1,e2,e3:ekr;
 var dupa:real;

 procedure opred_n(imya:string; var n:integer);
  var b:file of real; ss:string[80]; nn:longint;
  const l1:longint=1;
 begin
  assign(b,imya); reset(b);
  {n:=0; while not eof(b) do begin readln(b,ss); n:=n+1; end;}
  nn:=filesize(b); n:=round(sqrt(1.0*nn));
  if l1*n*n-nn<>0 then begin
   writeln('Opred_n: nn=',nn,' - ne sqr(n) !!!'); halt;
  end;
  writeln('n=',n);
  close(b);
 end;

 procedure vv_ma(imya:string; n:integer; var a:ma);
  var b:file of real; i,j,m:integer; dupa:^matr; r:real;
 begin
  new(dupa);
  assign(b,imya); reset(b);
  for i:=1 to n do begin for j:=1 to n do read(b,dupa^[i,j]); end;
  for i:=1 to n do for j:=1 to n do if i<>j then begin
   {za schot okrugl. m.b. nesimm. - simmetrizuem}
   r:=(dupa^[i,j]+dupa^[j,i])/2; dupa^[i,j]:=r; {dupa^[j,i]:=r;}   
  end;
  m:=0; for i:=1 to n do for j:=1 to i do begin m:=m+1; a[m]:=dupa^[i,j]; end;
  close(b);
  dispose(dupa);
 end;
 procedure vv_matr(imya:string; n:integer; var a:matr);
  var b:file of real; i,j,m:integer; {dupa:^matr;}
 begin
  assign(b,imya); reset(b);
  for i:=1 to n do begin for j:=1 to n do read(b,a[i,j]); end;
  close(b);
 end;

 procedure init_limits;
 begin
  x0_e:=0; x1_e:=10000.0;
  y0_e:=0; y1_e:=10000.0;
  nx:=6; ny_:=10;
  Emax:=4000.0; n_Emax:=4;
  kT:=293*k_smm1; writeln('kT=',kt:10:4,' cm-1');
 end;

 procedure opr_intens(i,j:integer; var X:matr; var s:real); var p,q:integer;
 begin
  s:=0; for p:=1 to n do for q:=1 to n do s:=s+SV^[p,i]*X[p,q]*SV^[q,j];
  {<x_i|X|x_j> = (x_i)p (X)pq (x_j)q = SZ_p,i X_pq SZ_q,j}
  s:=sqr(s);
 end;

Begin writeln;
 {rezhim_setk:='n';}
 new(SV); new(X1); new(X2); new(X3);
 writeln('memavail=',memavail);
 initmnozh;
 init_limits;
 opred_n('H.bin',n);
 vv_ma('S.bin',n,S); vv_ma('H.bin',n,H);
 vv_matr('X1.bin',n,X1^); vv_matr('X2.bin',n,X2^); vv_matr('X3.bin',n,X3^);
 {vyvlyevtrye(n,S); vyvlyevtrye(n,H);}
 {-----}
 diago(n,1e-5,H,S,SZ,SV^); { -> SV po strokam, a ne po stolbtsam!}

 writeln('diago otrab.');

 for i:=1 to n do for j:=i+1 to n do begin
  dupa:=sv^[i,j]; sv^[i,j]:=sv^[j,i]; sv^[j,i]:=dupa;
 end;
 {teper` po stolbtsam}
 assign(bb,'SZ.txt'); rewrite(bb);
 for i:=1 to n do writeln(bb,sz[i]:10:4);
 close(bb);
 assign(bb,'SV.txt'); rewrite(bb);
 for i:=1 to n do begin
  for j:=1 to n do write(bb,' ',SV^[j,i]:8:4); writeln(bb);
 end;
 close(bb);
 writeln('zapisali SZ i SV.');
(*
 for i:=1 to n do begin
  write(sz[i]:10:4,' ',sz[i]-sz[1]:10:4,' ');
  for j:=1 to {n}10 do write(SV^[j,i]:5:1); writeln;
 end;
 writeln('ENTER dlq prodolzh.'); readln;
*)
 {-----}
 {rasschot sp-ra pogloshch.}
 initgraph_12;

 prisv_ekr(et, x_y/2,x_y,3/4+0.01,1, 0,Emax,y0_e,y1_e,y0_e,y1_e,y0_e,y1_e);
 prisv_ramk(et,n_Emax,ny_,1,1); ramka(et); {termskhema}

 prisv_ekr(e1, x_y/2,x_y,2/4+0.01,3/4, et.x0,et.x1,0,1,0,1,0,1);
 prisv_ramk(e1,n_Emax,10,1,1); ramka(e1); {sp-r - polqriz. po x}

 prisv_ekr(e2, x_y/2,x_y,1/4+0.01,2/4, et.x0,et.x1,0,1,0,1,0,1);
 prisv_ramk(e2,n_Emax,10,1,1); ramka(e2); {sp-r - polqriz. po y}

 prisv_ekr(e3, x_y/2,x_y,0+0.01,1/4, et.x0,et.x1,0,1,0,1,0,1);
 prisv_ramk(e3,n_Emax,10,1,1); ramka(e3); {sp-r - polqriz. po y}

 for i:=n downto 1 do sz[i]:=sz[i]-sz[1];
 for i:=1 to n do if SZ[i]<=et.y1 then l(0,SZ[i],et.x1,SZ[i],et,9);
 assign(bb,'spectr3.out'); rewrite(bb);
 m:=0; for i:=1 to n do begin {nizhn. uroven`}
  arg:=-(SZ[i])/kT;
  if arg>-80 then begin
   exp_E_kT:=exp(arg);
   for j:=i+1 to n do begin {verkhn. uroven`}
    ny:=(SZ[j]-SZ[i]);
    opr_intens(i,j,X1^,intens_); intens1:=1E2*intens_*exp_E_kT;
    opr_intens(i,j,X2^,intens_); intens2:=1E2*intens_*exp_E_kT;
    opr_intens(i,j,X3^,intens_); intens3:=1E2*intens_*exp_E_kT;
    if (intens1>1e-3) or (intens2>1e-3) or (intens3>1e-3) then begin m:=m+1;
     if (ny<1e4) and (m<=16) then 
       writeln(   i:3,j:3,' ',ny:8:2,' ',intens1:7:4,intens2:7:4,intens3:7:4);
     writeln(bb,i:3,' ',j:3,' ',ny:8:2,' ',intens1:8:4,intens2:8:4,intens3:8:4);
     if intens1>1e-3 then begin
      l(ny,SZ[i],ny,SZ[j],et,10); l(ny,0,ny,intens1,e1,15);
     end;
     if intens2>1e-3 then begin
      l(ny,SZ[i],ny,SZ[j],et,12); l(ny,0,ny,intens2,e2,15);
     end;
     if intens3>1e-3 then begin
      l(ny,SZ[i],ny,SZ[j],et,12); l(ny,0,ny,intens3,e3,15);
     end;
    end {if intens};
   end {j};
  end {if arg}
 end {i};
 close(bb);
 {-----}
 dispose(X3); dispose(X2); dispose(X1); dispose(SV);
 readln; closegraph;
End.
