 type matr3=array[1..3,1..3] of real;
 type vect3=array[1..3] of real;

 procedure initvect(var r:vect3; x,y,z:real);
 begin r[1]:=x; r[2]:=y; r[3]:=z end;

 procedure initmatr(var n:matr3; a,b,c,d,e,f,g,h,i:real);
 begin
  n[1,1]:=a; n[1,2]:=b; n[1,3]:=c;
  n[2,1]:=d; n[2,2]:=e; n[2,3]:=f;
  n[3,1]:=g; n[3,2]:=h; n[3,3]:=i;
 end;

 procedure norm(var r:vect3); var c:real; i:integer;
 begin
  c:=sqrt(sqr(r[1])+sqr(r[2])+sqr(r[3])); for i:=1 to 3 do r[i]:=r[i]/c;
 end;
 function norma(a:vect3):real;
 begin norma:=sqrt(sqr(a[1])+sqr(a[2])+sqr(a[3])); end;
 function norma2(a:vect3):real;
 begin norma2:=sqr(a[1])+sqr(a[2])+sqr(a[3]); end;

 function scapro(a,b:vect3):real;
 begin scapro:=a[1]*b[1]+a[2]*b[2]+a[3]*b[3] end;

 procedure vecpro(b,c:vect3; var a:vect3);
 begin
  a[1]:=b[2]*c[3]-b[3]*c[2]; a[2]:=b[3]*c[1]-b[1]*c[3];
  a[3]:=b[1]*c[2]-b[2]*c[1];
 end;

 function rasst(a,b:vect3):real; var s:real; i:integer;
 begin s:=0; for i:=1 to 3 do s:=s+sqr(a[i]-b[i]); rasst:=sqrt(s); end;
 function rasst2(a,b:vect3):real; var s:real; i:integer;
 begin s:=0; for i:=1 to 3 do s:=s+sqr(a[i]-b[i]); rasst2:=s; end;

 function ugol(a,a0,b:vect3):real;
  var p,q:vect3; c,s,t05,u:real; i:integer;
 {byez ogr.obshch.ugol prinadl.[0..pi]; znak zavisit ot togo,s kakoj stor.
   smotrim na paru vyekt.,i mozhno brath '+'}
 begin
  for i:=1 to 3 do begin p[i]:=a[i]-a0[i]; q[i]:=b[i]-a0[i] end;
  norm(p); norm(q);
  c:=scapro(p,q);
  if c>1 then c:=1; if c<-1 then c:=-1; {b-ba s okrugl.}
  s:=sqrt(1-sqr(c));
  if c>=0 then begin
   t05:=s/(1+c); u:=2*arctan(t05)
  end else begin {popytka b-by s pogryeshn. ~180 grad}
   t05:=s/(1-c); u:=pi-2*arctan(t05);
  end;
  ugol:=u;
 end;
(*
 function ugol_(r1,r2,r3:vect):real;
  var i:integer; a,b:vect; cosfi,sinfi,tgfi,ctgfi,fi:real;
 begin
  for i:=1 to 3 do begin a[i]:=r1[i]-r2[i]; b[i]:=r3[i]-r2[i]; end;
  cosfi:=scapro(a,b)/sqrt(norma(a)*norma(b)); sinfi:=sqrt(1-sqr(cosfi));
  if abs(cosfi)>0.6 then begin
   tgfi:=sinfi/cosfi; fi:=arctan(tgfi);
   if fi<0 then fi:=fi+pi;
   if (sinfi<=0) and (cosfi<0) then fi:=pi;
  end else begin
   ctgfi:=cosfi/sinfi; fi:=pi/2-arctan(ctgfi);
  end;
  ugol:=fi;
 end;
*)
 function ugol2(a,b:vect3):real; var cosfi,sinfi,tgfi,ctgfi,fi:real;
 begin
  cosfi:=scapro(a,b)/sqrt(norma2(a)*norma2(b)); sinfi:=sqrt(1-sqr(cosfi));
  if abs(cosfi)>0.6 then begin
   tgfi:=sinfi/cosfi; fi:=arctan(tgfi);
   if fi<0 then fi:=fi+pi;
   if (sinfi<=0) and (cosfi<0) then fi:=pi;
  end else begin
   ctgfi:=cosfi/sinfi;fi:=pi/2-arctan(ctgfi);
  end;
  ugol2:=fi;
 end;

 {var pi05:real;}

 function ro(r1,r2,r3,r4:vect3):real;
  var p1,p2,p3,pp:vect3; c,s,t05,u:real; i:integer;
 begin
  for i:=1 to 3 do begin
   p1[i]:=r1[i]-r2[i]; p2[i]:=r3[i]-r2[i]; pp[i]:=r4[i]-r2[i];
  end;
  vecpro(p1,p2,p3);
  norm(p3); norm(pp);
  c:=scapro(p3,pp); s:=sqrt(1-sqr(c));
  t05:=s/(1+c); u:=2*arctan(t05); {ozhid.u~90 grad -> etoj f-ly dostat.}
  ro:=u-pi*0.5;
 end;

 function dvugr(r1,r2,r3,r4:vect3):real;
  var p1,p2,p3,p4:vect3; a,b,c,s,t05,u:real; i:integer;
 begin
  for i:=1 to 3 do begin
   p1[i]:=r1[i]-r2[i]; p2[i]:=r3[i]-r2[i]; p3[i]:=r4[i]-r3[i];
  end;
  norm(p1); norm(p3); norm(p2); {neobkh. dl`a vychit. prodol. komp.}
  a:=scapro(p1,p2);
  b:=scapro(p3,p2);
  for i:=1 to 3 do begin p1[i]:=p1[i]-a*p2[i]; p3[i]:=p3[i]-b*p2[i] end;
  {vychli prodolhn.sostavl.}
  norm(p1); norm(p3); norm(p2); vecpro(p2,p1,p4);
  {eto sootv.: dvugr>0 => pri vzglyadye ot 3 k 2 123 nado povor.
    dlya skoryejsh.sovm.s 234 imyenno protiv chas.stryelki}
  c:=scapro(p3,p1); s:=scapro(p3,p4);
  {vozm.abs(c) chuth >1 za sch.pogryesh., no eto nye myeshayet}
  if (s=0) and (c>0) then u:=0;
  if (s>0) and (c>0) then begin t05:=s/(1+c); u:=2*arctan(t05) end;
  if (s>0) and (c=0) then u:=pi/2;
  if (s>0) and (c<0) then begin t05:=s/(1-c); u:=pi-2*arctan(t05) end;
  if (s=0) and (c<0) then u:=pi;
  if (s<0) and (c<0) then begin t05:=s/(1-c); u:=pi-2*arctan(t05) end;
  if (s<0) and (c=0) then u:=3*pi/2;
  if (s<0) and (c>0) then begin t05:=s/(1+c); u:=2*pi+2*arctan(t05) end;
  {ispolhz.t05 - popytka b-by s pogryeshn. ~180 grad}
  dvugr:=u;
 end;
(*
 function dvugr_(r1,r2,r3,r4:vect3):real; {uproshch. - ignor. znak !!!}
  var i:integer; a,b,c,a_para,a_perp,c_para,c_perp:vect3; d:real;
 begin
  for i:=1 to 3 do begin
   a[i]:=r1[i]-r2[i]; b[i]:=r3[i]-r2[i]; c[i]:=r4[i]-r3[i];
  end;
  para_perp(b,a,a_para,a_perp); para_perp(b,c,c_para,c_perp);
  d:=ugol2(a_perp,c_perp);
  dvugr:=d;
 end;
*)

 procedure para_perp(osh,r:vect3; var para,perp:vect3);
 {vydel. iz vectora komponent, paral. i perp. drugomu vekt.}
  var a:real; i:integer;
 begin
  norm(osh);
  a:=scapro(osh,r);
  for i:=1 to 3 do begin para[i]:=a*osh[i]; perp[i]:=r[i]-para[i]; end;
 end;

{perekh. ot dekart. k sfer. koord. i obratno}
procedure find_xyz(var x,y,z:real; r,theta,fi:real);
begin
 z:=r*cos(theta); x:=r*sin(theta)*cos(fi); y:=r*sin(theta)*sin(fi);
end;
procedure find_sfer(x,y,z:real; var r,theta,fi:real); var ra,tg_theta,yx:real;
begin
 r:=sqrt(sqr(x)+sqr(y)+sqr(z)); ra:=sqrt(sqr(x)+sqr(y));
 if z<>0 then begin
  tg_theta:=ra/z; theta:=arctan(tg_theta); if theta<0 then theta:=theta+pi;
 end else theta:=pi/2;
 if x<>0 then begin
  yx:=y/x; fi:=arctan(yx);
  if x<0 then fi:=fi+pi else if y<0 then fi:=fi+2*pi;
 end else begin
  if y>0 then fi:=pi/2 else if y<0 then fi:=3*pi/2 else fi:=0;
 end;
end;

function obyom(a,b,c:vect3):real;
begin
 obyom:=a[1]*b[2]*c[3]+a[2]*b[3]*c[1]+a[3]*b[1]*c[2]
       -a[3]*b[2]*c[1]-a[2]*b[1]*c[3]-a[1]*b[3]*c[2]
end;

function sinugla(a,b:vect3):real; var s,s1,s2:real;
{primer ispol`z.: if sinugla(a,b)<0.001 ...}
begin
 s:=sqr(a[2]*b[3]-a[3]*b[2])+sqr(a[3]*b[1]-a[1]*b[3])
   +sqr(a[1]*b[2]-a[2]*b[1]);
 s1:=sqr(a[1])+sqr(a[2])+sqr(a[3]); s2:=sqr(b[1])+sqr(b[2])+sqr(b[3]);
 sinugla:=sqrt(s/(s1*s2))
end;

procedure reshen(g1,g2,g3:vect3; var r:vect3; l:vect3);
{ryesh.s-my G*r=l; g1..g3 - stroki matr.G; t.e.: g1*r=l[1] i t.d.}
 var c:real; r1,r2,r3:vect3; i:integer;
begin
 c:=1./obyom(g1,g2,g3);
 vecpro(g2,g3,r1); vecpro(g3,g1,r2); vecpro(g1,g2,r3);
 for i:=1 to 3 do r[i]:=(r1[i]*l[1]+r2[i]*l[2]+r3[i]*l[3])*c;
 {sledujushch. stroka neverna - sokhr. dl`a vyjasn.}
 {r[1]:=scapro(l,r1)*c; r[2]:=scapro(l,r2)*c; r[3]:=scapro(l,r3)*c;}
end;
(*
 procedure reshen_(a1,a2,a3:vect3; var al:vect3; x:vect3);
 {ryesh.s-my a1*al[1]+a2*al[2]+a3*al[3]=x = G*al=x; a1..a3 - stolbtsy matr.G;
   bylo zapis., chto eto sootv. perekh. ot dekart. koord. k koord. v bazise 
   krist. jach.; mozhno bylo by transponir. matr. G i obr. k RESHEN}
  var c:real; g1,g2,g3,r1,r2,r3:vect3; i:integer;
 begin
  g1:=a1; g2:=a2; g3:=a3;
  c:=1./obyom(g1,g2,g3);
  vecpro(g2,g3,r1); vecpro(g3,g1,r2); vecpro(g1,g2,r3);
  al[1]:=scapro(x,r1)*c; al[2]:=scapro(x,r2)*c; al[3]:=scapro(x,r3)*c;
 end;
*)

procedure Av(A:matr3; var v:vect3); var u:vect3; i,j:integer; s:real;
begin
 for i:=1 to 3 do begin
  s:=0; for j:=1 to 3 do s:=s+A[i,j]*v[j]; u[i]:=s;
 end; v:=u;
end;

procedure povorv(var v:vect3; osh:vect3; fi:real);
{povor. vektora vokrug osi na zad. ugol}
 var i:integer; proekc,normal,vsp:vect3; a1:real;
begin
 norm(osh); a1:=scapro(v,osh);
 for i:=1 to 3 do begin proekc[i]:=a1*osh[i]; normal[i]:=v[i]-proekc[i] end;
 vecpro(osh,normal,vsp);
 for i:=1 to 3 do v[i]:=proekc[i]+cos(fi)*normal[i]+sin(fi)*vsp[i];
end;

procedure rotate(a:vect3; cfi,sfi,cpsi,spsi,chi,shi:real; var b:vect3); 
{zad. kosinusy i sinusy uglov Ejlera}
 var c:vect3;
begin
 b[1]:=cfi*a[1]+sfi*a[2]; b[2]:=-sfi*a[1]+cfi*a[2]; b[3]:=a[3];
 c[1]:=cpsi*b[1]+spsi*b[3]; c[2]:=b[2]; c[3]:=-spsi*b[1]+cpsi*b[3];
 b[1]:=chi*c[1]+shi*c[2]; b[2]:=-shi*c[1]+chi*c[2]; b[3]:=c[3]
end;

 type bazis=array[1..3] of vect3;

 procedure postr_bazis(aa,bb,cc,alpha,beta,gamma:real; var a:bazis);
  {var v:real;}
 begin
  a[1][1]:=aa; a[1][2]:=0; a[1][3]:=0;
  a[2][1]:=bb*cos(gamma); a[2][2]:=bb*sin(gamma); a[2][3]:=0;
  {obozn. baz. vekt. a,b,c, a ikh dliny - aa,bb,cc;
   c*a=cc*aa*cos(beta), c*b=cc*bb*cos(alpha);
   a[3]=b[3]=0 -> eto s-ma 2-kh ur.s 2 nyeizv. - c[3] ukhodit;
   c[1] i c[2] - ryesh.etoj s-my}
  a[3][1]:=cc*cos(beta);
  a[3][2]:=cc*((cos(alpha)-cos(beta)*cos(gamma))/sin(gamma));
  {a c[3] nakh.iz abs(c)=cc}
  a[3][3]:=sqrt(sqr(cc)-sqr(a[3][1])-sqr(a[3][2]));
  {v:=obyom(a[1],a[2],a[3]); write('v=',v:10:4); readln;}
 end;

