{neobkh. vnachale $i subrgeom - v metode 5 ispol`z. vekt. proizv.;
  krome togo, podpr. perevoda nabora tochek iz ob'jektn. s-my koord.
  v labor. ispol`z. perem. i iz usescach, i iz uses_gr3; resheno
  pomest. ikh v usescach, a matritsu eo sdel. parametrom, no dl`a
  etogo jejo nado opis. kak prinadl. tipu, imejushch. im`a, a ne
  array[]; logichno opis. kak prinadl. tipu matr3 iz subrgeom.
  (2000,3,4: prog. peredelyvaetsa, esli etot fragment ustareet - udalit`).
}
{vvodim 3 s-my:
  (1) ob'jektn. s-ma; v nej zadajutsa f(r) i koord. osobykh tochek ("atomov");
  (2) lokal. s-ma; parallel`na (1), no nach. koord. smeshcheno v tochku r0
    (zadannuju v s-me (1));
  (3) s-ma nabl`udatel`a, ona zhe - labor. s-ma; v nej Ox - po ekranu vpravo,
    Oy - po ekranu vverkh, Oz - k zritel`u.
  Predvar. soglash.: kazhd. vektor zapis. v 3-kh s-makh; v (3) - <imya>,
    v (1) - <imya>_o, v (2) - <imya>_l .
  Dl`a perekh. mezhdu s-mami vv. matr. Oe; po opr. Oe[i,j] est` j-ja komp.
    i-go baz. vektora lab. s-my v objektn. s-me. Inache govor`a, stroki
    matritsy Oe - eto baz. vektory lab. s-my v obj. s-me.
    -Oe_o[1]-      |      1
    -Oe_o[2]- * Oe_o[1] = 0 .  Pri r0=0 eto interpr.: Oe*r_o=r.
    -Oe_o[3]-      |      0
  Dalee r0 zapis. kak r0_o, chtoby podcherk., chto on zadan v obj. s-me.
  Perekh. mezhdu s-mami:
    r_l:=r_o-r0_o                  r_o:=r_l+r0_o ;
    Oe*r_l=r                       (Oe)T *r=r_l .
  Zapis. perekh. mezhdu obj. s-moj i s-moj nabl-l`a kak 2 podpr. -
    obj2nab i nab2obj.
}
{no[1..3] - napravl. osveshchenija, zapis. v labor. s-me.}
{osob-sti, s k-rymi zhelatel`no razobratsa, a esli mozhno - ustranit`:
  - v 3-m metode os` z ili ots., ili srazu tolst. s pereryvami;
  - v 5-m metode pri 1-m prokhode -> tochku;
  - v 5-m metode posle 2-go prokh. osi ostajutsa tk. na fone figur;
  - v 4-m metode dl`a figury, poluch. interpol`atsiej mezhdu tochkami,
      poluch. "grav`ura" - net plavnykh perekhodov jarkosti.
  - v 5-m metode, pokhozhe, dostatochno khranit` 2 stolbtsa matritsy
      z(ix,iy), a ne vs`u matr.
  - v posl. metode, esli blizhajsh. k zritel`u stenka peresek. puzyr`, 
      nado izobr. ego vnutrennost` belym, a ne chornym, chtoby otlich. 
      ot fona.
}
 {---------------------}
 var Oe:matr3; r0_o,r0:vect3; dr0:real;
 var v_labor_sme:boolean;
 type functi3=function(x,y,z:real):real;
 var no:vect3 {napravl. osveshch.};
 type atom_gra=record r,r0,r1:vect3; end;
 var r_atom:array[1..40] of atom_gra; n_atom:integer;
 type svyaz_gra=record a:array[1..2] of integer; r0,r1:vect3; end;
 var svyaz_at:array[1..40] of svyaz_gra; n_svyaz_at:integer;
 var r_osi_i,l_osi_i,r_osi_l,l_osi_l,radi_atom:real;
 {-----------------}
 procedure init_Oe(z1,z2,z3,x1,x2,x3:real);
 {Zadany neispravlenn. baz. vektory Oz i Ox labor. s-my v objektn. s-me;
   Oz - naprav. k nabl`udatel`u, Ox - primern. naprav. osi Ox nabl-l`a;
   normir. Oz, iz Ox srez. kompon. vdol` Oz i vosst. Oy;
   iz poluch. vekt. stroim matr. preobr.
 }
  var Ox,Oy,Oz:vect3; a:real; i:integer;
 begin
  initvect(Oz,z1,z2,z3); initvect(Ox,x1,x2,x3);
  if norma(Oz)<1E-5 then begin writeln('Init_Oe: podozr. mal. Oz'); halt; end;
  norm(Oz); a:=scapro(Oz,Ox);
  for i:=1 to 3 do Ox[i]:=Ox[i]-a*Oz[i];
  if norma(Ox)<1E-5 then begin writeln('Init_Oe: podozr. mal. Ox'); halt; end;
  norm(Ox); vecpro(Oz,Ox,Oy);
  for i:=1 to 3 do begin Oe[1,i]:=Ox[i]; Oe[2,i]:=Oy[i]; Oe[3,i]:=Oz[i]; end;
 end;

 procedure obj2nab(r_o:vect3; var r:vect3); var i,j:integer; r_l:vect3;
 begin
  for i:=1 to 3 do r_l[i]:=r_o[i]-r0_o[i];
  for i:=1 to 3 do begin r[i]:=0;
   for j:=1 to 3 do r[i]:=r[i]+Oe[i,j]*r_l[j];
  end;
 end;
 procedure nab2obj(r:vect3; var r_o:vect3); var i,j:integer; r_l:vect3;
 begin
  for i:=1 to 3 do begin r_l[i]:=0;
   for j:=1 to 3 do r_l[i]:=r_l[i]+Oe[j,i]*r[j];
  end;
  for i:=1 to 3 do r_o[i]:=r_l[i]+r0_o[i];
 end;
 {------------------}
 function atomy(x,y,z,radi:real):boolean;
 {ispytat` skorost` s ispol`z. r0 i r1 !}
  var i:integer; g:boolean; r:vect3; label ende;
 begin
  initvect(r,x,y,z);
  g:=false; for i:=1 to n_atom do if rasst(r,r_atom[i].r)<radi then begin
   g:=true; goto ende;
  end;
  ende:
  atomy:=g;
 end;
 function svyazi_at(x,y,z,r0:real):boolean;
  var osh,r1,r2,r,rr,para,perp:vect3; i,j:integer; g:boolean; dlina,a:real;
  {var a1,a2:atom_gra;}
  label ende,ende2;
 begin
  initvect(rr,x,y,z);
  g:=false; for i:=1 to n_svyaz_at do begin
   if (x<svyaz_at[i].r0[1]) or (x>svyaz_at[i].r1[1]) then goto ende2;
   if (y<svyaz_at[i].r0[2]) or (y>svyaz_at[i].r1[2]) then goto ende2;
   if (z<svyaz_at[i].r0[3]) or (z>svyaz_at[i].r1[3]) then goto ende2;
   r1:=r_atom[svyaz_at[i].a[1]].r; r2:=r_atom[svyaz_at[i].a[2]].r;
   for j:=1 to 3 do begin osh[j]:=r2[j]-r1[j]; r[j]:=rr[j]-r1[j]; end;
   dlina:=norma(osh);
   norm(osh);
   a:=scapro(osh,r);
   for j:=1 to 3 do begin para[j]:=a*osh[j]; perp[j]:=r[j]-para[j]; end;
   {vydelili iz r komp., paral. i perp. k osi}
   if (a>=0) and (a<=dlina) and (norma(perp)<=r0) then begin
    g:=true; goto ende;
   end;
   ende2:
  end;
  ende:
  svyazi_at:=g;
 end;
 function iskhodn_osi(x,y,z,tols,razm:real):boolean;
  var p1,p2,p3:boolean; r,r_o:vect3;
 begin
  if v_labor_sme then begin {perekh. k obj. s-me}
   initvect(r,x,y,z); nab2obj(r,r_o); x:=r_o[1]; y:=r_o[2]; z:=r_o[3];
  end;
  p1:=(sqrt(sqr(y)+sqr(z))<tols) and (abs(x)<razm);
  p2:=(sqrt(sqr(z)+sqr(x))<tols) and (abs(y)<razm);
  p3:=(sqrt(sqr(x)+sqr(y))<tols) and (abs(z)<razm);
  iskhodn_osi:=p1 or p2 or p3;
 end;
 function lokal_osi(x,y,z,tols,razm:real):boolean;
  var p1,p2,p3:boolean; r,r_o:vect3;
 begin
  if v_labor_sme then begin {perekh. k obj. s-me}
   initvect(r,x,y,z); nab2obj(r,r_o); x:=r_o[1]; y:=r_o[2]; z:=r_o[3];
  end;
  p1:=(sqrt(sqr(y-r0_o[2])+sqr(z-r0_o[3]))<tols) and (abs(x-r0_o[1])<razm);
  p2:=(sqrt(sqr(z-r0_o[3])+sqr(x-r0_o[1]))<tols) and (abs(y-r0_o[2])<razm);
  p3:=(sqrt(sqr(x-r0_o[1])+sqr(y-r0_o[2]))<tols) and (abs(z-r0_o[3])<razm);
  lokal_osi:=p1 or p2 or p3;
 end;
 {----------------}

 var elem_dlina:real; {tipichno - 1, no esli v A - 1e-8; v f_3d_6 - dlq vyv.}

 procedure init_3d; var i,j:integer; n:vect3;
 {rekom. pri neobkh. kopir. blok prisvoenij ots`uda i zamen`at` neobkh-moe}
 begin
  elem_dlina:=1;
  initvect(r0_o,0,0,0); {tochka, okr-sti k-roj izobr.}
  init_Oe(1,-5,2, 5,1,0);
  {rekom.: x,y,z, -y,x,0 ; 1-ja trojka - koord. tochki nabl-nija (v objektn.
    s-me); 2-ja trojka - - os` Ox nabl`-l`a - v goriz. pl-sti i perp.
    napr-niju na tochku nabl-nija}
  dr0:=10.0;
  initvect(no,1,1,0); norm(no); n:=no; obj2nab(n,no);
  {obj2nab sootv. tomu, chto vekt. zadan v obj. s-me, i ego perev. v
    labor. s-mu; 0,0,1 bez perev. -> v labor. s-me na zritel`a => puzyr`}
  v_labor_sme:=false;
  n_atom:=0; n_svyaz_at:=0;
  r_osi_i:=0.2; l_osi_i:=10; r_osi_l:=0.2; l_osi_l:=10; radi_atom:=0.5;
 end;

 procedure test_ortonorm_Oe;
  var a:array[1..3,1..3] of real; b:real; i,j,k:integer;
 begin
  for i:=1 to 3 do for j:=i to 3 do begin
   a[i,j]:=0; for k:=1 to 3 do a[i,j]:=a[i,j]+Oe[i,k]*Oe[j,k];
  end;
  b:=0; for i:=1 to 3 do b:=b+abs(a[i,i]-1);
  for i:=1 to 2 do for j:=i+1 to 3 do b:=b+abs(a[i,j]);
  if b>1.0e-5 then begin writeln('Matr. Oo ne ortonorm.'); halt; end;
  if abs(norma(no)-1)>1.0e-5 then begin writeln('abs(no)<>1'); halt; end;
 end;

 {function fun(x,y,z:real; f:functi3):real; forward;}
 function fun(x,y,z:real; f:functi3):real; {x,y,z - vsegda v labor. s-me}
  var r,r_o:vect3; g:real; i:integer;
  const b=1e24;
  label ende;
 begin
  if not v_labor_sme then begin {perekh. k obj. s-me}
   initvect(r,x,y,z); nab2obj(r,r_o); x:=r_o[1]; y:=r_o[2]; z:=r_o[3]; r:=r_o;
  end;
  g:=0;
  if r_osi_i>0 then if iskhodn_osi(x,y,z,r_osi_i,l_osi_i) then begin g:=b; goto ende; end;
  if r_osi_l>0 then if lokal_osi(x,y,z,r_osi_l,l_osi_l) then begin  g:=b; goto ende; end;
  if radi_atom>0 then if atomy(x,y,z,radi_atom) then begin g:=b; goto ende; end;
  if svyazi_at(x,y,z,{0.05}radi_atom*0.4) then begin g:=b; goto ende; end;
  g:=f(x,y,z);
  ende:
  fun:=g;
 end;

 {-----------------}
(*
 procedure f_3D_0(e:ekr; f:functi3);
  var i,j,k,i0,i1,j0,j1,imin,imax,jmin,jmax,kmax,color:integer;
  var x,y,z:real;
  label end_k;
  var ff:real;
 begin
  i0:=x2i(e.x0,e); i1:=x2i(e.x1,e); j0:=y2j(e.y0,e); j1:=y2j(e.y1,e);
  imin:=i0; imax:=i1; if i1<i0 then begin imin:=i1; imax:=i0 end;
  jmin:=j0; jmax:=j1; if j1<j0 then begin jmin:=j1; jmax:=j0 end;
  kmax:=imax-imin+1{50};
  for i:=imin to imax do begin x:=e.x0+(e.x1-e.x0)*((i-imin)/(imax-imin));
  for j:=jmin to jmax do begin y:=e.y0+(e.y1-e.y0)*((j-jmin)/(jmax-jmin));
   po(x,y,e,getmaxcolor);
   for k:=kmax downto 0 do begin z:=e.z0+(k/kmax)*(e.z1-e.z0);
    ff:=fun(x,y,z,f); if ff>e.f1 then goto end_k;
   end {k};
   end_k:
   color:=round((k/kmax)*getmaxcolor);
   po(x,y,e,color);
  end {j};
  {write(chr($0D));} {dl`a sn`at. po Ctrl+Break}
  end {i};
 end;

 procedure f_3D_1(e:ekr; fu:functi3);
  var i0,i1,j0,j1,i,j,color,imin,imax,jmin,jmax,k,kmax:integer;
    x,y,z,s,fmae,f,d,xx,fmin,fmax:real; grad:array[1..3] of real;
  label end_k;
 begin
  test_ortonorm_Oe;
  d:=1.0E-5*(e.z1-e.z0);
  i0:=x2i(e.x0,e); i1:=x2i(e.x1,e); j0:=y2j(e.y0,e); j1:=y2j(e.y1,e);
  imin:=i0; imax:=i1; if i1<i0 then begin imin:=i1; imax:=i0 end;
  jmin:=j0; jmax:=j1; if j1<j0 then begin jmin:=j1; jmax:=j0 end;
  kmax:=imax-imin; if (jmax-jmin)>kmax then kmax:=jmax-jmin;
  for i:=imin to imax do begin x:=e.x0+(e.x1-e.x0)*((i-imin)/(imax-imin));
  for j:=jmin to jmax do begin y:=e.y0+(e.y1-e.y0)*((j-jmin)/(jmax-jmin));
   po(x,y,e,getmaxcolor);
   s:=0; fmin:=0; fmax:=0; f:=0; for k:=kmax downto 0 do begin
    z:=e.z0+(k/kmax)*(e.z1-e.z0);
    fmae:=f;
    f:=fun(x,y,z,fu);
    if k=0 then begin fmin:=f; fmax:=f; end else begin
     if f<fmin then fmin:=f; if f>fmax then fmax:=f;
     {dl`a otsenok f0 i f1 pri probnom zapuske}
    end;
    {write(x:10:4,y:10:4,z:10:4,f:10:4,chr($0D));}
    if (k>0) and (peresek(fmae,f,e.f1) {or peresek(fmae,f,e.f1*0.5)})
      then begin
     grad[1]:=(fun(x+d,y,z,fu)-fun(x-d,y,z,fu))/(2*d);
     grad[2]:=(fun(x,y+d,z,fu)-fun(x,y-d,z,fu))/(2*d);
     grad[3]:=(fun(x,y,z+d,fu)-fun(x,y,z-d,fu))/(2*d);
     if (grad[1]=0) and (grad[2]=0) and (grad[3]=0) then begin
      grad[1]:=no[1]; grad[2]:=no[2]; grad[3]:=no[3];
      {na sluchaj, esli est` gran`, parall. pl-sti ekrana}
     end;
     xx:=1/sqrt(sqr(grad[1])+sqr(grad[2])+sqr(grad[3]));
     grad[1]:=grad[1]*xx; grad[2]:=grad[2]*xx; grad[3]:=grad[3]*xx;
     {s:=sqr(grad[1])+sqr(grad[2]);} {eto -> izobr. v vide krasiv. puzyr`a}
     xx:=grad[1]*no[1]+grad[2]*no[2]+grad[3]*no[3];
     s:=0.5+0.5*xx*xx*xx;
     {write(grad[1]:10:4,grad[2]:10:4,grad[3]:10:4,s:10:4,chr($0D));}
     goto end_k;
    end;
   end {k};
   end_k:
   {write(x:10:4,y:10:4,fmin:10:4,fmax:10:4,s:10:4,chr($0D));}
   color:=round(getmaxcolor*(s{/4})); srez(color,0,getmaxcolor);
   po(x,y,e,color);
  end;
  write(chr($0D)); {dl`a sn`at. po Ctrl+Break}
  end;
 end;

 procedure f_3D_2(e:ekr; fu:functi3);
 {rasst. do pov-sti f=e.f1}
  var i0,i1,j0,j1,i,j,color,imin,imax,jmin,jmax,k,kmax:integer;
    x,y,z,s,fmae,f,d,xx,fmin,fmax:real; grad:array[1..3] of real;
  label end_k;
 begin
  test_ortonorm_Oe;
  i0:=x2i(e.x0,e); i1:=x2i(e.x1,e); j0:=y2j(e.y0,e); j1:=y2j(e.y1,e);
  imin:=i0; imax:=i1; if i1<i0 then begin imin:=i1; imax:=i0 end;
  jmin:=j0; jmax:=j1; if j1<j0 then begin jmin:=j1; jmax:=j0 end;
  kmax:=50;
  for i:=imin to imax do begin x:=e.x0+(e.x1-e.x0)*((i-i0)/(i1-i0));
  for j:=jmin to jmax do begin y:=e.y0+(e.y1-e.y0)*((j-j0)/(j1-j0));
   putpixel(i,j,getmaxcolor);
   s:=0; {esli ne najd`om f>=e.f1, pust` na vykh. budet s=0}
   f:=e.f0;
   for k:=kmax downto 0 do begin z:=e.z0+(k/kmax)*(e.z1-e.z0);
    fmae:=f; f:=fun(x,y,z,fu);
    if (k=kmax) and (f>=e.f1) then begin s:=1; goto end_k; end;
    if f>e.f1 then begin s:=(z-e.z0)/(e.z1-e.z0); goto end_k; end;
   end {k};
   end_k:
   color:=round(getmaxcolor*s); srez(color,0,getmaxcolor);
   putpixel(i,j,color);
  end {j};
  write(chr($0D)); {dl`a sn`at. po Ctrl+Break}
  end {i};
 end;

 procedure f_3D_3(e:ekr; fu:functi3);
 {1-j vstr. ekstrem.}
  var i0,i1,j0,j1,i,j,color,imin,imax,jmin,jmax,k,kmax:integer;
    x,y,z,s,fmae,f,d,xx,fmin,fmax:real; grad:array[1..3] of real;
  var f1,f2,f3:real;
  label end_k,ende;
  function maxi:boolean; begin maxi:=(f1<f2) and (f2>=f3); end;
  function mini:boolean; begin mini:=(f1>f2) and (f2<=f3); end;
 begin
  test_ortonorm_Oe;
  i0:=x2i(e.x0,e); i1:=x2i(e.x1,e); j0:=y2j(e.y0,e); j1:=y2j(e.y1,e);
  imin:=i0; imax:=i1; if i1<i0 then begin imin:=i1; imax:=i0 end;
  jmin:=j0; jmax:=j1; if j1<j0 then begin jmin:=j1; jmax:=j0 end;
  kmax:=50;
  for i:=imin to imax do begin x:=e.x0+(e.x1-e.x0)*((i-i0)/(i1-i0));
  for j:=jmin to jmax do begin y:=e.y0+(e.y1-e.y0)*((j-j0)/(j1-j0));
   putpixel(i,j,getmaxcolor);
   s:=0; {esli ne najd`om ekstrem., pust` na vykh. budet s=0}
   for k:=kmax downto 0 do begin z:=e.z0+(k/kmax)*(e.z1-e.z0);
    f1:=f2; f2:=f3; f3:=fun(x,y,z,fu);
    if abs(f3-e.f0)<0.05*abs(e.f1-e.f0) then f3:=e.f0;
    {chtoby khvosty ot odnogo ekstremuma ne zaslon`ali dr. ekstremumy}
    if k>=kmax-1 then goto ende; {1-e 2 tochki - tk. podgot. f1 i f2}
    if maxi or mini then begin
     {predp., chto tipichno e.f0=0;
       f2 prinadl. e.f0-(e.f1-e.f0)..e.f0+(e.f1-e.f0),
       tak chto s prinadl. -1..1}
     s:=(f2-e.f0)/(e.f1-e.f0); if s<-1 then s:=-1; if s>1 then s:=1; goto end_k;
    end;
    ende:
   end {k};
   end_k:
   color:=(getmaxcolor div 2)+round(getmaxcolor*s/2);
   {chtoby izolin. sovp., no togda 0 -> color=7, i zashkal. ne odnovr.}
   {color:=round(getmaxcolor*(0.5+0.5*s));}
   srez(color,0,getmaxcolor);
   putpixel(i,j,color);
  end {j};
  write(chr($0D)); {dl`a sn`at. po Ctrl+Break}
  end {i};
 end;

 procedure f_3D_4(e:ekr; fu:functi3);
 {maks./sredn. f}
  var i0,i1,j0,j1,i,j,color,imin,imax,jmin,jmax,k,kmax:integer;
    x,y,z,s,fmae,f,d,xx,fmin,fmax,fsr:real; grad:array[1..3] of real;
 begin
  test_ortonorm_Oe;
  i0:=x2i(e.x0,e); i1:=x2i(e.x1,e); j0:=y2j(e.y0,e); j1:=y2j(e.y1,e);
  imin:=i0; imax:=i1; if i1<i0 then begin imin:=i1; imax:=i0 end;
  jmin:=j0; jmax:=j1; if j1<j0 then begin jmin:=j1; jmax:=j0 end;
  kmax:=50;
  for i:=imin to imax do begin x:=e.x0+(e.x1-e.x0)*((i-i0)/(i1-i0));
  for j:=jmin to jmax do begin y:=e.y0+(e.y1-e.y0)*((j-j0)/(j1-j0));
   putpixel(i,j,getmaxcolor);
   fmax:=e.f0; fsr:=0;
   for k:=kmax downto 0 do begin z:=e.z0+(k/kmax)*(e.z1-e.z0);
    f:=fun(x,y,z,fu); if f>fmax then fmax:=f; fsr:=fsr+f;
   end {k};
   fsr:=fsr/(kmax+1);
   if fmax>e.f1 then fmax:=e.f1;
   s:=(fmax-e.f0)/(e.f1-e.f0);
   {s:=(fsr-e.f0)/(e.f1-e.f0);}
   color:=round(getmaxcolor*s); srez(color,0,getmaxcolor);
   putpixel(i,j,color);
  end {j};
  write(chr($0D)); {dl`a sn`at. po Ctrl+Break}
  end {i};
 end;

 procedure f_3D_5(e:ekr; {matr_preob:matr3; n:vect3;} fu:functi3);
 {grad(f)*n}
  var i0,i1,j0,j1,i,j,color,imin,imax,jmin,jmax,k,kmax:integer;
    x,y,z,s,fmae,f,d,xx,fmin,fmax:real; grad:array[1..3] of real;
  var z0,z1,f0,f1:real;
  label end_k;
 begin
  test_ortonorm_Oe;
  d:=1.0E-5*(e.z1-e.z0);
  i0:=x2i(e.x0,e); i1:=x2i(e.x1,e); j0:=y2j(e.y0,e); j1:=y2j(e.y1,e);
  imin:=i0; imax:=i1; if i1<i0 then begin imin:=i1; imax:=i0 end;
  jmin:=j0; jmax:=j1; if j1<j0 then begin jmin:=j1; jmax:=j0 end;
  kmax:=50;
  for i:=imin to imax do begin x:=e.x0+(e.x1-e.x0)*((i-i0)/(i1-i0));
  for j:=jmin to jmax do begin y:=e.y0+(e.y1-e.y0)*((j-j0)/(j1-j0));
   putpixel(i,j,getmaxcolor);
   s:=0; {esli ne najd`om f>=e.f1, pust` na vykh. budet s=0}
   f:=e.f0;
   for k:=kmax downto 0 do begin z:=e.z0+(k/kmax)*(e.z1-e.z0);
    fmae:=f; f:=fun(x,y,z,fu);
    if (k=kmax) and (f>=e.f1) then begin s:=1; goto end_k; end;
    if f>e.f1 then begin
     {nashli poverkhnost`; utochnim ejo polozh.}
     z0:=e.z0+((k+1)/kmax)*(e.z1-e.z0); z1:=z; f0:=fmae-e.f1; f1:=f-e.f1;
     repeat
      z:=0.5*(z0+z1); f:=fun(x,y,z,fu)-e.f1;
      if (f*f0<0) or (f=0) then begin z1:=z; f1:=f; end
      else {if f*f1<0 then} begin z0:=z; f0:=f; end;
     until abs(z1-z0)<1.0e-8*abs(e.z1-e.z0);
     grad[1]:=(fun(x+d,y,z,fu)-fun(x-d,y,z,fu))/(2*d);
     grad[2]:=(fun(x,y+d,z,fu)-fun(x,y-d,z,fu))/(2*d);
     grad[3]:=(fun(x,y,z+d,fu)-fun(x,y,z-d,fu))/(2*d);
     if (grad[1]=0) and (grad[2]=0) and (grad[3]=0) then begin
      grad[1]:=no[1]; grad[2]:=no[2]; grad[3]:=no[3];
      {na sluchaj, esli vvedeny el-ty, vnutri k-rykh fun=const}
     end;
     xx:=1/sqrt(sqr(grad[1])+sqr(grad[2])+sqr(grad[3]));
     grad[1]:=grad[1]*xx; grad[2]:=grad[2]*xx; grad[3]:=grad[3]*xx;
     xx:=grad[1]*no[1]+grad[2]*no[2]+grad[3]*no[3]; s:=0.5+0.5*xx; goto end_k;
    end;
   end {k};
   end_k:
   color:=round(getmaxcolor*s); srez(color,0,getmaxcolor);
   putpixel(i,j,color);
  end {j};
  write(chr($0D)); {dl`a sn`at. po Ctrl+Break}
  end {i};
 end;
*)

 procedure f_3D_6(e:ekr; {matr_preob:matr3; n:vect3;} fu:functi3);
 {norm. k z(x,y) *n}
 {predusm. vyv. z i grad v fajl dl`a avtonom. prosmotra}
  var i0,i1,j0,j1,i,j,color,imin,imax,jmin,jmax,k,kmax:integer;
  label end_k;
  type atype=array[0..1000] of real; var a,aa:^atype;
  var grad,vx,vy:vect3;
  var x,y,z,s,fmae,f,d,xx,fmin,fmax,z0,z1,f0,f1,dx,dy,dzx,dzy:real;
  var bb:text; gut:boolean;
 begin
  test_ortonorm_Oe;
  assign(bb,'z_grad.txt'); rewrite(bb);
  new(a); new(aa);
  d:=1.0E-5*(e.z1-e.z0);
  {i0:=x2i(e.x0,e); i1:=x2i(e.x1,e); j0:=y2j(e.y0,e); j1:=y2j(e.y1,e);}
  i0:=e.ix0; i1:=e.ix1; j0:=e.iy0; j1:=e.iy1;  
  imin:=i0; imax:=i1; if i1<i0 then begin imin:=i1; imax:=i0 end;
  jmin:=j0; jmax:=j1; if j1<j0 then begin jmin:=j1; jmax:=j0 end;
  kmax:={50}100;
  dx:=(e.x1-e.x0)*(1/(i1-i0)); dy:=(e.y1-e.y0)*(1/(j1-j0));
  for i:=imin to imax do begin x:=e.x0+(i-i0)*dx;
  a^:=aa^;
  for j:=jmin to jmax do begin y:=e.y0+(j-j0)*dy;
   if (i<imax) and (j<jmax) then putpixel(i,j,getmaxcolor);
   s:=0; {esli ne najd`om f>=e.f1, pust` na vykh. budet s=0}
   aa^[j-jmin]:={0}e.z0;
   f:=e.f0;
   for k:=kmax downto 0 do begin z:=e.z0+(k/kmax)*(e.z1-e.z0);
    fmae:=f; f:=fun(x,y,z,fu); 
    if (k=kmax) and (f>=e.f1) then begin s:=1; goto end_k; end;
    if f>e.f1 then begin
     {nashli poverkhnost`; utochnim ejo polozh.}
     z0:=e.z0+((k+1)/kmax)*(e.z1-e.z0); z1:=z; f0:=fmae-e.f1; f1:=f-e.f1;
     repeat
      z:=0.5*(z0+z1); f:=fun(x,y,z,fu)-e.f1;
      if (f*f0<0) or (f=0) then begin z1:=z; f1:=f; end
      else {if f*f1<0 then} begin z0:=z; f0:=f; end;
     until abs(z1-z0)<1.0e-8*abs(e.z1-e.z0);
     aa^[j-jmin]:=z;
     goto end_k;
    end;
   end {k};
   end_k:
   if s=1 then aa^[j-jmin]:=e.z1;
  end {j};
  if i>imin then for j:=jmin to jmax-1 do begin
   dzx:=aa^[j-jmin]-a^[j-jmin]; initvect(vx,dx,0,dzx);
   dzy:=a^[j-jmin+1]-a^[j-jmin]; initvect(vy,0,dy,dzy);
   if (a^[j-jmin]=e.z0) or (aa^[j-jmin]=e.z0)
     or (a^[j-jmin+1]=e.z0) then begin gut:=false; color:=0 end else begin
    gut:=true; vecpro(vx,vy,grad);
    {mozhno anal.: grad = (-dzx*dy, -dx*dzy, dx*dy)}
    norm(grad); xx:=scapro(grad,no);
    if a^[j-jmin]<>e.z1 then s:=0.5+0.5*xx else s:=1;
    color:=round(getmaxcolor*s); srez(color,0,getmaxcolor);
   end;
   {if abs(a^[j-jmin]-e.z1)<1e6*abs(e.z1-e.z0) then color:=getmaxcolor;}
   {esli peredn. stenka peresek. puzyr`, vnutr-st` - bel., chtoby otl. ot fona}
   putpixel(i-1,j,color);
   if abs(a^[j-jmin]-e.z0)>1e-6*abs(e.z1-e.z0) then begin
     if not gut then initvect(grad,0,0,0);
     writeln(bb,i-1-imin:5,j-jmin:5,a^[j-jmin]/elem_dlina:10:4,
     grad[1]:10:4,grad[2]:10:4,grad[3]:10:4);
   end;
  end {j};
  write(chr($0D)); {dl`a sn`at. po Ctrl+Break}
  end {i};
  dispose(aa); dispose(a);
  close(bb);
 end;

 {----------------}

 procedure ato(var aa:atom_gra; x,y,z:real); var a:real; k:integer;
 begin
  a:=radi_atom/elem_dlina; if (a<0.1) or (a>10) then begin
   writeln('Ato: radi_atom,elem_dlina=',radi_atom:16,' ',elem_dlina:16,' !!!');
   halt;
  end;
  a:=1.1*radi_atom;
  with aa do begin
   initvect(r,x*elem_dlina,y*elem_dlina,z*elem_dlina);
   for k:=1 to 3 do begin r0[k]:=r[k]-a; r1[k]:=r[k]+a; end;
  end;
 end;

 procedure svq(i,j:integer); var b:real;ri,rj,r0_,r1_:vect3; k:integer;
 begin
  b:=radi_atom/elem_dlina; if (b<0.1) or (b>10) then begin
   writeln('Svq: radi_atom,elem_dlina=',radi_atom:16,' ',elem_dlina:16,' !!!');
   halt;
  end;
  b:=0.5*radi_atom;
  ri:=r_atom[i].r; rj:=r_atom[j].r;
  for k:=1 to 3 do begin
   r0_[k]:=ri[k]; if rj[k]<r0_[k] then r0_[k]:=rj[k];
   r1_[k]:=ri[k]; if rj[k]>r0_[k] then r1_[k]:=rj[k];
  end;
  n_svyaz_at:=n_svyaz_at+1;
  with svyaz_at[n_svyaz_at] do begin
   a[1]:=i; a[2]:=j;
   for k:=1 to 3 do begin r0[k]:=r0_[k]-b; r1[k]:=r1_[k]+b; end;
  end;
 end;

