 const naziv:string[8]='abnormal';

 {type vect3=array[1..3] of real; matr3=array[1..3,1..3] of real;}

 type minimum=record
  r0:vect3; E_dna_smm1:real; {polozh. minimuma, E v minimume}
  a:matr3; {matr. pereh. ot labor. s-my k s-me s osqmi wdolx norm. koleb.;
             rrr=A*rr;  1   -a1*-   rr1
                        0 = -a2*- * rr2  =>
             rr=a1*, t.e. wekt. norm. koleb. - po strokam.
           }
  k,ny,x0:vect3; {k[i] - zhostkosti; iz nih nahodqt x0, obesp. ksi=x/x0}
 end;
 var minima:array[1..7000] of minimum; nminima:integer;

 type baz_func=record nr_min,n1,n2,n3:integer; end;
 const ndim_max=250; {fakti`. ndim = nbaz_ftsij}
 var baz_ftsii:array[1..ndim_max] of baz_func; nbaz_ftsij:integer;

 var Emax_smm1,Emax_:real;
 {Emax_smm1 - dlq wybora baz. f-cij - otbras., esli ozhid. E>Emax_smm1;
    tipichno 10000 sm-1;
  Emax_ - dlq interpolqcii - esli net blizk. tochek, E:=Emax_smm1_;
    tipichno 200000 sm-1 (perev. v SGS !).
 }
 var m:array[1..3] of real; {m[i] - eff. massy vdol` razn. koord.}
 var x1_0,x1_1,x2_0,x2_1,x3_0,x3_1:real;
 var dx,dv:real; {obshch. dlq vseh koord-t}
 var rezhim_setk:char;
 type ar=array[1..{70000}100000] of real;
 var x,y,z,E:^ar; np:longint;
 type type_pot=array[0..60,0..60,0..60] of real;
 var fpot:file of real; pot:^type_pot;

 {----------------}

 procedure add_baz_func(nr_min_,n1_,n2_,n3_:integer);
 begin
  nbaz_ftsij:=nbaz_ftsij+1;
  with baz_ftsii[nbaz_ftsij] do begin
   nr_min:=nr_min_; n1:=n1_; n2:=n2_; n3:=n3_;
  end;
 end;

 var f_:array[0..100,0..2] of real;
 {f_[v,0..2]=Hv, Hv' i Hv'' - polin. Ermita i ih proizw. pri fiks. ksi;
   normir. mnozh. ignor.}

 procedure func_osc(v:integer; x0,x:real; var f,f1,f2:real);
 {proverit`: esli vstav. proverku exp_() na =0 -
   uskoritsa li v real. sluchajakh !!!
 }
 {f - f-ciq, f1 i f2 - e@ proizwodnye}
 {Differencir. rekurrent. sootn. dlq Hn - poluch. sootn. dlq Hn' i Hn''
   (opusk. normir. mnozh.):
   Hn=2*Hn-1*x-2*(n-1)*Hn-2
   Hn'=2Hn-1'*x+2Hn-1-2*(n-1)*Hn-2'
   Hn''=2Hn-1''+4Hn-1'-2*(n-1)Hn-2''
   Analogi`no dlq WF osc-ra i e@ proizw. polu`.:
   f   = exp(-x^2/2) * Hn(x);
   f'  = exp()       * (Hn' - Hn*x)
   f'' = exp()       * (Hn'' - 2*Hn'*x + Hn*(x^2-1))
 }
 {zamech.: f1 i f2 poluch. kak proizv. po ksi=x/x0; nam treb. proizv. po x;
   ksi=x/x0 => df/dksi=(df/dx)*x0 => df/dx=(df/dksi)/x0;
   analog. d2f/dx2=(d2f/dksi2)/x0^2.
 }
  var n:integer; norm,ksi,exp__:real;
 begin
  {writeln('func_osc poluch. upr.');}
  ksi:=x/x0;
  {writeln(' x,x0,ksi=',x:10:4,x0:10:4,ksi:10:4);}
  exp__:=exp_(-sqr(ksi)/2);
  if exp__{=0}<=1e-6 then begin f:=0; f1:=0; f2:=0; exit; end;
  f_[0,0]:=1; f_[0,1]:=0; f_[0,2]:=0;
  f_[1,0]:=2*ksi; f_[1,1]:=2; f_[1,2]:=0;
  for n:=2 to v do begin
   f_[n,0]:=2*f_[n-1,0]*ksi-2*(n-1)*f_[n-2,0];
   f_[n,1]:=2*f_[n-1,1]*ksi+2*f_[n-1,0]-2*(n-1)*f_[n-2,1];
   f_[n,2]:=2*f_[n-1,2]*ksi+4*f_[n-1,1]-2*(n-1)*f_[n-2,2];
  end;
  norm:=1/sqrt(sqrt(pi))*1/sqrt(x0)*1/sqrt(pw(2,v)*fa(v));
  f :=norm*exp__ * f_[v,0];
  f1:=norm*exp__ * ( f_[v,1]-f_[v,0]*ksi );
  f2:=norm*exp__ * ( f_[v,2]-2*f_[v,1]*ksi+f_[v,0]*(sqr(ksi)-1) );
  f1:=f1/x0; f2:=f2/sqr(x0);
  {writeln(' f,f2=',f:10:4,f2:10:4);}
  {writeln('func_osc: vozvr.');}
 end;

 procedure sinusoid(n1,n2,n3:integer; r:vect3;
   var f,f_2_r1,f_2_r2,f_2_r3:real);
 {v prqmoug. (x1_0..x1_1 po x i analog. po y) dolzhno umestitsa
   n1 poluperiodov po x i n2 po y; f_2_r1, f_2_r2 - 2-e proizvodnye;
   dolzhna byt` normir.
 }
  var {x1,x2,x3,}f1,f2,f3,{d1,d2,d3,}k1,k2,k3:real; v,norm_mnozh:real;
 begin
  v:=(x1_1-x1_0)*(x2_1-x2_0)*(x3_1-x3_0);
  k1:=n1*pi/(x1_1-x1_0); f1:=sin((r[1]-x1_0)*k1);
  k2:=n2*pi/(x2_1-x2_0); f2:=sin((r[2]-x2_0)*k2);
  k3:=n3*pi/(x3_1-x3_0); f3:=sin((r[3]-x3_0)*k3);
(*
  writeln(r[1]/angst:10:4,r[2]/angst:10:4,n1:4,n2:4,' ',k1:16,' ',k2:16,
    f1:10:4,f2:10:4{,chr($0D)});
  readln;
*)
  {Int f dv = v 1-mer. sluch. =v/2, 2-mer. - v/4, 3-mer. - v/8}
  norm_mnozh:=1/sqrt(v*0.125);
  f:=norm_mnozh*f1*f2*f3;
  f_2_r1:=-f*sqr(k1);
  f_2_r2:=-f*sqr(k2);
  f_2_r3:=-f*sqr(k3);
 end;

 procedure ff(nr:integer; v1,v2,v3:integer; r:vect3;
   var f,f_2_r1,f_2_r2,f_2_r3:real);
 {f - funk., f_2_r1,f_2_r2,f_2_r3 - 2-e proizwodnye v labor. s-me}
  var i,j:integer; rr,rrr:vect3;
  var f1,f1q,f1qq,f2,f2q,f2qq,f3,f3q,f3qq:real;
  var f1_r1,f1_r2,f1_r3,f2_r1,f2_r2,f2_r3,f3_r1,f3_r2,f3_r3:real;
  var f1_2_r1,f1_2_r2,f1_2_r3,f2_2_r1,f2_2_r2,f2_2_r3,f3_2_r1,f3_2_r2,f3_2_r3:real;
 begin
 if nr=0 then begin sinusoid(v1,v2,v3,r,f,f_2_r1,f_2_r2,f_2_r3); exit; end;
 with minima[nr] do begin
  {writeln('ff poluch. upr.');}
  for i:=1 to 3 do rr[i]:=r[i]-r0[i];
  for i:=1 to 3 do begin
   rrr[i]:=0; for j:=1 to 3 do rrr[i]:=rrr[i]+A[i,j]*rr[j];
  end;
  func_osc(v1,x0[1],rrr[1],f1,f1q,f1qq);
  {writeln(' -> f1,f1qq=',f1:10:4,f1qq:10:4);}
  if f1=0 then begin f:=0; f_2_r1:=0; f_2_r2:=0; exit; end;
  func_osc(v2,x0[2],rrr[2],f2,f2q,f2qq);
  {writeln(' -> f2,f2qq=',f2:10:4,f2qq:10:4);}
  if f2=0 then begin f:=0; f_2_r1:=0; f_2_r2:=0; exit; end;
  func_osc(v3,x0[3],rrr[3],f3,f3q,f3qq);
  {writeln(' -> f3,f3qq=',f3:10:4,f3qq:10:4);}
  if f3=0 then begin f:=0; f_2_r1:=0; f_2_r2:=0; exit; end;
  f1_r1:=f1q*a[1,1]; f1_r2:=f1q*a[1,2]; f1_r3:=f1q*a[1,3];
  f2_r1:=f2q*a[2,1]; f2_r2:=f2q*a[2,2]; f2_r3:=f2q*a[2,3];
  f3_r1:=f3q*a[3,1]; f3_r2:=f3q*a[3,2]; f3_r3:=f3q*a[3,3];
  {f1_r1 etc. - eto 1-e proizv. v labor. s-me}
  f1_2_r1:=f1qq*sqr(a[1,1]); f1_2_r2:=f1qq*sqr(a[1,2]); f1_2_r3:=f1qq*sqr(a[1,3]);
  f2_2_r1:=f2qq*sqr(a[2,1]); f2_2_r2:=f2qq*sqr(a[2,2]); f2_2_r3:=f2qq*sqr(a[2,3]);
  f3_2_r1:=f3qq*sqr(a[3,1]); f3_2_r2:=f3qq*sqr(a[3,2]); f3_2_r3:=f3qq*sqr(a[3,3]);
  {f1_2_r1 etc. - eto 2-e proizv. v labor. s-me; perekr`ostn. ne treb.}
  {v 2-mer. slu`.:
  f:=f1*f2;
  f_2_r1:= f1_2_r1*f2 + f1*f2_2_r1 + 2*f1_r1*f2_r1;
  f_2_r2:= f1_2_r2*f2 + f1*f2_2_r2 + 2*f1_r2*f2_r2;
  }
  f:=f1*f2*f3;
  f_2_r1:=
    f1_2_r1*f2*f3 + f1*f2_2_r1*f3 + f1*f2*f3_2_r1
    + 2*f1_r1*f2_r1*f3 + 2*f1_r1*f2*f3_r1 + 2*f1*f2_r1*f3_r1;
  f_2_r2:=
    f1_2_r2*f2*f3 + f1*f2_2_r2*f3 + f1*f2*f3_2_r2
    + 2*f1_r2*f2_r2*f3 + 2*f1_r2*f2*f3_r2 + 2*f1*f2_r2*f3_r2;
  f_2_r3:=
    f1_2_r3*f2*f3 + f1*f2_2_r3*f3 + f1*f2*f3_2_r3
    + 2*f1_r3*f2_r3*f3 + 2*f1_r3*f2*f3_r3 + 2*f1*f2_r3*f3_r3;
  {writeln('ff: vozvr.');}
 end {with};
 end;

 {--------}

